## Introduction
This guide aims at illustrating how to integrate traditional IDPs into IDP Bridge to enable SSI-based authentication with SSI Wallets. The documentation assumes that you have the following services which are up and running. 

- *keycloak* running at *8081* if deployed locally or a dedicated domain name if deployed in prod
- *idp-bridge-local* running at *8080* if deployed locally or a dedicated domain name if deployed in prod

To enable a correct OIDC communication between Keycloak & IDPBridge, the 3 following configurations must be satisfied:
- Configure correctly *keycloak* and *idp-bridge-local* in the hosts file of your OS if they are deployed locally.
- Create *scopes* in IDP Bridge and for each *scope*, we can create different *credential mappings*. The latter will be used as references to extract attributes in user credentials and finally issue *tokens* returned to Keycloak
- Create OIDC Client for Keycloak in IDP Bridge, which includes *redirect_uri*, authorized *scopes*, etc

## Configuration Procedure
Please read carefully the following steps to perform correct configuration:

### 1. Local OS hosts file
<mark>If you have services running on prod, please skip this section</mark>

Add the following domains *keycloak* and *idp-bridge-local* in the hosts file of your OS.

```bash
# Local hosts for SSI MVP
127.0.0.1 idp-bridge-local
127.0.0.1 keycloak
```

> Please **DO NOT** access Keycloak & IDP Bridge via localhost, use their configured domain names instead:
>- http://keycloak:8081/
>- http://idp-bridge-local:8080/


### 2. Create Scopes
To configure IDP Bridge, please access with swagger-ui link: http://idp-bridge-local:8080/swagger-ui/index.html or via the corresponding url on your prod environment:

For illustration purpose, this document create a scope named `bankId` from endpoint below. You can use other scope name as needed:
```
POST http://idp-bridge-local:8080/oidc/scopes 
```
```json
{
  "name": "bankId",
  "description": "authenticate user with BankId Credential"
}
```

### 3. Create credential mappings
For IDP Bridge to extract correctly from user credentials, please use the following endpoint to create token-credential mappings:
```
POST http://idp-bridge-local:8080//oidc/scopes/mappings
```
The payload below shows configuration of *jwt_vc_json* credential mappings:
> *scope* field in the request parameter should be filled with `bankId`.

````json
[
  {
    "claim": "given_name",
    "claimPath": "$.vc.credentialSubject.givenName",
    "credentialType": "BankId",
    "credentialFormat": "jwt_vc_json"
  },
  {
    "claim": "family_name",
    "claimPath": "$.vc.credentialSubject.familyName",
    "credentialType": "BankId",
    "credentialFormat": "jwt_vc_json"
  }
]
````


The *claimPath* must be conform to JsonPath. You can remove your mappings in case of misconfiguration via `http://idp-bridge-local:8080/oidc/scopes/{scopeName}`. 

You will have two options which is either remove scope and associated mappings or mappings only, depending on the *mappingOnly* parameter.

This configuration tells IDP Bridge to generate Verifiable Presentation request which asks User for *firstName*, *lastName* of EmployeeCredential in *jwt_vc_json* format.

You can also add more configuration to tell IDP Bridge to ask for *email* for example.


### 4. Create OIDC Clients
The next step is to create a OIDC Client for Keycloak. For this purpose, follow the two processes below which MUST be performed *in parallel*:

Open both Keycloak (via: http://keycloak:8081) and IDPBridge (via http://idp-bridge-local:8080/swagger-ui/index.html). Please use the corresponding URIs if your services are deployed on prod.

#### Step 1
On the Keycloak windows, access to the *Administration Console* with admin username and password.
> By default it should be set to:
> - Username: *admin*
> - Password: *admin*

#### Step 2
On the Keycloak windows, create a new **OpenID Connect v1.0** Identity Provider. 

![Image Keycloak_OIDC_Identity_Provider](images/Keycloak_OIDC_IDP_Provider.png)

It will open the *Identity Providers* configurations menu, which needs to be filled in.

Go to the section *Import Extrnal IDP Config", copy/paste the URL of our *IDP Bridge* configuration: `http://idp-bridge-local:8080/.well-known/openid-configuration` and click on *import* button to import the configuration.

![Image Keycloak_OIDC_Identity_Provider_Import](images/Keycloak_OIDC_IDP_Import.png)

Thanks to the import, some fields were automatically filled in, but there are still some fields that need to be manually completed using the *IDP Bridge* swagger.

Go back to the first section and copy paste the *Redirect URI* which has been generated by Keycloak and will be usefull on the IDP Bridge windows to create a *client ID* and *client Secret* for Keycloak in the next step.

```bash
redirect_uri=http://keycloak:8081/realms/master/broker/oidc/endpoint
```

#### Step 3
On the IDP Bridge windows, go to *OIDC API* section and call the `POST /oidc/clients` request to create a new OIDC Client and get back the `client ID` and `client Secret` needed.

![Image Keycloak_OIDC_Identity_Provider_Swagger](images/Keycloak_OIDC_IDP_Swagger.png)

Information :
- You SHOULD use the *redirect_uri* from the previous step.
- You MUST specify all authorized scopes for Keycloak to use later on. Keep in mind that Keycloak can only use scopes registered with IDP Bridge !
- You SHOULD therefore **at a minimum** list the scope `bankId` you configured earlier. Only registered scopes can be used by Keycloak to communicate with IDP Bridge.

An example of such request can be found below:

```json
{
  "client_name": "keycloak",
  "redirect_uris": [
    "http://keycloak:8081/realms/master/broker/oidc/endpoint"
  ],
  "scopes": [
    "openid", "eviden", "auth", "employee", "mdoc", "bankId"
  ]
}
```
The request should return a JSON object containing the necessary information for Keycloak: the *client_name*, *client_id*, and *client_secret*.

#### Step 4
Go back to the Keycloak windows, and go to the section *OpenID Connect Config* :
- Remove the url in the *Logout URL* field
- Select the *Client Authentication* mechanism, set it to "Client secret sent as basic auth"
- Fill in the *client ID* and the *client Secret* with ones obtained from previous request.
- Add into the scopes fields the following: `openid bankId`. Note that the openid scope is a MUST to tell IDP Bridge that this is a OIDC protocol. We use additional scope such as `bankId` to let communicate with IDP Bridge which credential Keycloak wants to request from User.

![Image Keycloak_OIDC_Identity_Provider_Client](images/Keycloak_OIDC_IDP_Client.png)

The configuration is complete, and you just need to click the "Save" button !

## FAQ:
### 1. Authentication error
**I get an error at the moment I click on the Authentication button on the Keycloak interface to be redirected to IDPBridge?**

In this case, there are 2 possible causes:
- The *redirect_uri* registered with IDP Bridge is not correct
- The *scope* Keycloak uses has not been registered with Keycloak

### 2. Wallet error
**I get an error after Wallet submits successfully required VCs**

There are 2 possible reasons:
- Keycloak has not a correct *clientSecret*, you can create a new one on the IDPBridge swagger
- Keycloak could not validate token signature. You need to make sure that on your OIDC Identity Provider configuration in Keycloak, you insert the public token signing key of IDP Bridge in the PKCS#8 format. The token signing key is exposed at *http://idp-bridge-local:8080/oauth2/jwks* you specify well the *jwks_uri* of IDPBridge for token signature validation.
<mark>If desired, you can also disable signature verification.</mark> The problem often only occurs on local development but usually works well in production.
